#!/usr/bin/env python
import sys

def closest(lst, Number):
    aux = []
    for val in lst:
        aux.append(abs(Number-val))
    return aux.index(min(aux))


def percent(value, mybr):
    return (value - mybr)/mybr

def calc(xtal, myBR):
    xtalhz = xtal * 1e6
    lowbr = int((xtalhz / 64 / myBR) -1)
    lowres = (xtalhz / 64 / (lowbr +1))
    hibr = int((xtalhz / 16 / myBR) -1)
    hires = (xtalhz / 16 / (hibr +1))
    return lowbr, lowres, hibr, hires

def main(args):
    wantedBR = int(args[1])
    test = -2, -1, 0, 1, 2
    xtal = int(args[0])
    myList = []
    foundBR = {}
    i = 0
    print('Low baudrate list')
    for n in test:
        lowbr, lowres, hibr,hires = calc(xtal, wantedBR)
        value = xtal * 1e6 / (64 * (lowbr +n +1))
        myList.append(percent(value, wantedBR))
        print('{0:.2%}\t{1}\t{2}'.format(percent(value, wantedBR),
                                                        lowbr +n,
                                                        i))
        foundBR[i] = lowbr
        i += 1
    print('High baudrate list')
    for n in test:
        value = xtal * 1e6 / (16 * (hibr +n +1))
        myList.append(percent(value, wantedBR))
        print('{0:.2%}\t{1}\t{2}'.format(percent(value, wantedBR),
                                                 hibr +n,
                                                 i))
        foundBR[i] = hibr
        i += 1
    print('Preferred %s' % foundBR[closest(myList,0)])
if __name__ == '__main__':
    args = (4,)
    if len(sys.argv) > 1:
        args = (sys.argv[1:])
    main(args)
